## WDS enumerations and flags WDS enumerations and flags |

## Functions

const gchar * | qmi_wds_ip_family_get_string ()
const gchar * | qmi_wds_profile_family_get_string ()
gchar * | qmi_wds_technology_preference_build_string_from_mask ()
const gchar * | qmi_wds_extended_technology_preference_get_string ()
const gchar * | qmi_wds_call_type_get_string ()
const gchar * | qmi_wds_call_end_reason_get_string ()
const gchar * | qmi_wds_verbose_call_end_reason_get_string ()
const gchar * | qmi_wds_verbose_call_end_reason_type_get_string ()
const gchar * | qmi_wds_verbose_call_end_reason_mip_get_string ()
const gchar * | qmi_wds_verbose_call_end_reason_internal_get_string ()
const gchar * | qmi_wds_verbose_call_end_reason_cm_get_string ()
const gchar * | qmi_wds_verbose_call_end_reason_3gpp_get_string ()
const gchar * | qmi_wds_verbose_call_end_reason_ppp_get_string ()
const gchar * | qmi_wds_verbose_call_end_reason_ehrpd_get_string ()
const gchar * | qmi_wds_verbose_call_end_reason_ipv6_get_string ()
const gchar * | qmi_wds_connection_status_get_string ()
const gchar * | qmi_wds_data_bearer_technology_get_string ()
const gchar * | qmi_wds_network_type_get_string ()
const gchar * | qmi_wds_data_system_network_type_get_string ()
gchar * | qmi_wds_rat_3gpp2_build_string_from_mask ()
gchar * | qmi_wds_rat_3gpp_build_string_from_mask ()
gchar * | qmi_wds_so_cdma1x_build_string_from_mask ()
gchar * | qmi_wds_so_evdo_reva_build_string_from_mask ()
const gchar * | qmi_wds_get_current_settings_requested_settings_get_string ()
const gchar * | qmi_wds_pdp_type_get_string ()
const gchar * | qmi_wds_pdp_header_compression_type_get_string ()
const gchar * | qmi_wds_pdp_data_compression_type_get_string ()
const gchar * | qmi_wds_qos_class_identifier_get_string ()
const gchar * | qmi_wds_traffic_class_get_string ()
gchar * | qmi_wds_authentication_build_string_from_mask ()
const gchar * | qmi_wds_profile_type_get_string ()
const gchar * | qmi_wds_delivery_order_get_string ()
const gchar * | qmi_wds_sdu_error_ratio_get_string ()
const gchar * | qmi_wds_sdu_residual_bit_error_ratio_get_string ()
const gchar * | qmi_wds_sdu_erroneous_delivery_get_string ()
gchar * | qmi_wds_packet_statistics_mask_flag_build_string_from_mask ()
const gchar * | qmi_wds_ds_profile_error_get_string ()
const gchar * | qmi_wds_autoconnect_setting_get_string ()
const gchar * | qmi_wds_autoconnect_setting_roaming_get_string ()
const gchar * | qmi_wds_data_call_status_get_string ()
const gchar * | qmi_wds_data_call_type_get_string ()
const gchar * | qmi_wds_data_system_get_string ()
const gchar * | qmi_wds_dormancy_status_get_string ()
const gchar * | qmi_wds_extended_data_bearer_technology_3gpp2_get_string ()
const gchar * | qmi_wds_extended_data_bearer_technology_3gpp_get_string ()
const gchar * | qmi_wds_radio_access_technology_get_string ()
const gchar * | qmi_wds_set_event_report_transfer_statistics_get_string ()
const gchar * | qmi_wds_so_evdo_rev0_get_string ()
const gchar * | qmi_wds_so_evdo_revb_get_string ()
const gchar * | qmi_wds_tethered_call_type_get_string ()
const gchar * | qmi_wds_attach_pdn_list_action_get_string ()
const gchar * | qmi_wds_client_type_get_string ()
const gchar * | qmi_wds_ip_support_type_get_string ()

## Types and Values

enum | QmiWdsIpFamily
enum | QmiWdsProfileFamily
enum | QmiWdsTechnologyPreference
enum | QmiWdsExtendedTechnologyPreference
enum | QmiWdsCallType
enum | QmiWdsCallEndReason
enum | QmiWdsVerboseCallEndReasonType
enum | QmiWdsVerboseCallEndReasonMip
enum | QmiWdsVerboseCallEndReasonInternal
enum | QmiWdsVerboseCallEndReasonCm
enum | QmiWdsVerboseCallEndReason3gpp
enum | QmiWdsVerboseCallEndReasonPpp
enum | QmiWdsVerboseCallEndReasonEhrpd
enum | QmiWdsVerboseCallEndReasonIpv6
enum | QmiWdsConnectionStatus
enum | QmiWdsDataBearerTechnology
enum | QmiWdsNetworkType
enum | QmiWdsDataSystemNetworkType
enum | QmiWdsRat3gpp2
enum | QmiWdsRat3gpp
enum | QmiWdsSoCdma1x
enum | QmiWdsSoEvdoRevA
enum | QmiWdsGetCurrentSettingsRequestedSettings
enum | QmiWdsPdpType
enum | QmiWdsPdpHeaderCompressionType
enum | QmiWdsPdpDataCompressionType
enum | QmiWdsQosClassIdentifier
enum | QmiWdsTrafficClass
enum | QmiWdsAuthentication
enum | QmiWdsProfileType
enum | QmiWdsDeliveryOrder
enum | QmiWdsSduErrorRatio
enum | QmiWdsSduResidualBitErrorRatio
enum | QmiWdsSduErroneousDelivery
enum | QmiWdsPacketStatisticsMaskFlag
enum | QmiWdsDsProfileError
enum | QmiWdsAutoconnectSetting
enum | QmiWdsAutoconnectSettingRoaming
enum | QmiWdsDataCallStatus
enum | QmiWdsDataCallType
enum | QmiWdsDataSystem
enum | QmiWdsDormancyStatus
enum | QmiWdsExtendedDataBearerTechnology3gpp
enum | QmiWdsExtendedDataBearerTechnology3gpp2
enum | QmiWdsRadioAccessTechnology
enum | QmiWdsSetEventReportTransferStatistics
enum | QmiWdsSoEvdoRev0
enum | QmiWdsSoEvdoRevB
enum | QmiWdsTetheredCallType
enum | QmiWdsAttachPdnListAction
enum | QmiWdsClientType
enum | QmiWdsIpSupportType
#define | QMI_WDS_RATE_UNAVAILABLE

## Object Hierarchy

        GEnum
        ├── QmiWdsAttachPdnListAction
        ├── QmiWdsAutoconnectSetting
        ├── QmiWdsAutoconnectSettingRoaming
        ├── QmiWdsCallEndReason
        ├── QmiWdsCallType
        ├── QmiWdsClientType
        ├── QmiWdsConnectionStatus
        ├── QmiWdsDataBearerTechnology
        ├── QmiWdsDataCallStatus
        ├── QmiWdsDataCallType
        ├── QmiWdsDataSystem
        ├── QmiWdsDataSystemNetworkType
        ├── QmiWdsDeliveryOrder
        ├── QmiWdsDormancyStatus
        ├── QmiWdsDsProfileError
        ├── QmiWdsExtendedTechnologyPreference
        ├── QmiWdsIpFamily
        ├── QmiWdsIpSupportType
        ├── QmiWdsNetworkType
        ├── QmiWdsPdpDataCompressionType
        ├── QmiWdsPdpHeaderCompressionType
        ├── QmiWdsPdpType
        ├── QmiWdsProfileFamily
        ├── QmiWdsProfileType
        ├── QmiWdsQosClassIdentifier
        ├── QmiWdsRadioAccessTechnology
        ├── QmiWdsSduErroneousDelivery
        ├── QmiWdsSduErrorRatio
        ├── QmiWdsSduResidualBitErrorRatio
        ├── QmiWdsTetheredCallType
        ├── QmiWdsTrafficClass
        ├── QmiWdsVerboseCallEndReason3gpp
        ├── QmiWdsVerboseCallEndReasonCm
        ├── QmiWdsVerboseCallEndReasonEhrpd
        ├── QmiWdsVerboseCallEndReasonInternal
        ├── QmiWdsVerboseCallEndReasonIpv6
        ├── QmiWdsVerboseCallEndReasonMip
        ├── QmiWdsVerboseCallEndReasonPpp
        ╰── QmiWdsVerboseCallEndReasonType
        GFlags
        ├── QmiWdsAuthentication
        ├── QmiWdsExtendedDataBearerTechnology3gpp
        ├── QmiWdsExtendedDataBearerTechnology3gpp2
        ├── QmiWdsGetCurrentSettingsRequestedSettings
        ├── QmiWdsPacketStatisticsMaskFlag
        ├── QmiWdsRat3gpp
        ├── QmiWdsRat3gpp2
        ├── QmiWdsSetEventReportTransferStatistics
        ├── QmiWdsSoCdma1x
        ├── QmiWdsSoEvdoRev0
        ├── QmiWdsSoEvdoRevA
        ├── QmiWdsSoEvdoRevB
        ╰── QmiWdsTechnologyPreference

## Description

This section defines enumerations and flags used in the WDS service interface.

## Functions

### qmi_wds_ip_family_get_string ()

    const gchar *
    qmi_wds_ip_family_get_string (QmiWdsIpFamily val);

Gets the nickname string for the QmiWdsIpFamily specified at `val` .

#### Parameters

val | a QmiWdsIpFamily. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_profile_family_get_string ()

    const gchar *
    qmi_wds_profile_family_get_string (QmiWdsProfileFamily val);

Gets the nickname string for the QmiWdsProfileFamily specified at `val` .

#### Parameters

val | a QmiWdsProfileFamily. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.22

### qmi_wds_technology_preference_build_string_from_mask ()

    gchar *
    qmi_wds_technology_preference_build_string_from_mask
                                   (QmiWdsTechnologyPreference mask);

Builds a string containing a comma-separated list of nicknames for each QmiWdsTechnologyPreference in `mask` .

#### Parameters

mask | bitmask of QmiWdsTechnologyPreference values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### qmi_wds_extended_technology_preference_get_string ()

    const gchar *
    qmi_wds_extended_technology_preference_get_string
                                   (QmiWdsExtendedTechnologyPreference val);

Gets the nickname string for the QmiWdsExtendedTechnologyPreference specified at `val` .

#### Parameters

val | a QmiWdsExtendedTechnologyPreference. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_call_type_get_string ()

    const gchar *
    qmi_wds_call_type_get_string (QmiWdsCallType val);

Gets the nickname string for the QmiWdsCallType specified at `val` .

#### Parameters

val | a QmiWdsCallType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_call_end_reason_get_string ()

    const gchar *
    qmi_wds_call_end_reason_get_string (QmiWdsCallEndReason val);

Gets the nickname string for the QmiWdsCallEndReason specified at `val` .

#### Parameters

val | a QmiWdsCallEndReason. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_verbose_call_end_reason_get_string ()

    const gchar *
    qmi_wds_verbose_call_end_reason_get_string
                                   (QmiWdsVerboseCallEndReasonType type,
                                    gint16 reason);

Get verbose call end reason based on the reason type.

#### Parameters

type | a QmiWdsVerboseCallEndReasonType. |
reason | the reason id. |

#### Returns

a string with the reason, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_verbose_call_end_reason_type_get_string ()

    const gchar *
    qmi_wds_verbose_call_end_reason_type_get_string
                                   (QmiWdsVerboseCallEndReasonType val);

Gets the nickname string for the QmiWdsVerboseCallEndReasonType specified at `val` .

#### Parameters

val | a QmiWdsVerboseCallEndReasonType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_verbose_call_end_reason_mip_get_string ()

    const gchar *
    qmi_wds_verbose_call_end_reason_mip_get_string
                                   (QmiWdsVerboseCallEndReasonMip val);

Gets the nickname string for the QmiWdsVerboseCallEndReasonMip specified at `val` .

#### Parameters

val | a QmiWdsVerboseCallEndReasonMip. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_verbose_call_end_reason_internal_get_string ()

    const gchar *
    qmi_wds_verbose_call_end_reason_internal_get_string
                                   (QmiWdsVerboseCallEndReasonInternal val);

Gets the nickname string for the QmiWdsVerboseCallEndReasonInternal specified at `val` .

#### Parameters

val | a QmiWdsVerboseCallEndReasonInternal. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_verbose_call_end_reason_cm_get_string ()

    const gchar *
    qmi_wds_verbose_call_end_reason_cm_get_string
                                   (QmiWdsVerboseCallEndReasonCm val);

Gets the nickname string for the QmiWdsVerboseCallEndReasonCm specified at `val` .

#### Parameters

val | a QmiWdsVerboseCallEndReasonCm. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_verbose_call_end_reason_3gpp_get_string ()

    const gchar *
    qmi_wds_verbose_call_end_reason_3gpp_get_string
                                   (QmiWdsVerboseCallEndReason3gpp val);

Gets the nickname string for the QmiWdsVerboseCallEndReason3gpp specified at `val` .

#### Parameters

val | a QmiWdsVerboseCallEndReason3gpp. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_verbose_call_end_reason_ppp_get_string ()

    const gchar *
    qmi_wds_verbose_call_end_reason_ppp_get_string
                                   (QmiWdsVerboseCallEndReasonPpp val);

Gets the nickname string for the QmiWdsVerboseCallEndReasonPpp specified at `val` .

#### Parameters

val | a QmiWdsVerboseCallEndReasonPpp. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_verbose_call_end_reason_ehrpd_get_string ()

    const gchar *
    qmi_wds_verbose_call_end_reason_ehrpd_get_string
                                   (QmiWdsVerboseCallEndReasonEhrpd val);

Gets the nickname string for the QmiWdsVerboseCallEndReasonEhrpd specified at `val` .

#### Parameters

val | a QmiWdsVerboseCallEndReasonEhrpd. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_verbose_call_end_reason_ipv6_get_string ()

    const gchar *
    qmi_wds_verbose_call_end_reason_ipv6_get_string
                                   (QmiWdsVerboseCallEndReasonIpv6 val);

Gets the nickname string for the QmiWdsVerboseCallEndReasonIpv6 specified at `val` .

#### Parameters

val | a QmiWdsVerboseCallEndReasonIpv6. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_connection_status_get_string ()

    const gchar *
    qmi_wds_connection_status_get_string (QmiWdsConnectionStatus val);

Gets the nickname string for the QmiWdsConnectionStatus specified at `val` .

#### Parameters

val | a QmiWdsConnectionStatus. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_data_bearer_technology_get_string ()

    const gchar *
    qmi_wds_data_bearer_technology_get_string
                                   (QmiWdsDataBearerTechnology val);

Gets the nickname string for the QmiWdsDataBearerTechnology specified at `val` .

#### Parameters

val | a QmiWdsDataBearerTechnology. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_network_type_get_string ()

    const gchar *
    qmi_wds_network_type_get_string (QmiWdsNetworkType val);

Gets the nickname string for the QmiWdsNetworkType specified at `val` .

#### Parameters

val | a QmiWdsNetworkType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_data_system_network_type_get_string ()

    const gchar *
    qmi_wds_data_system_network_type_get_string
                                   (QmiWdsDataSystemNetworkType val);

Gets the nickname string for the QmiWdsDataSystemNetworkType specified at `val` .

#### Parameters

val | a QmiWdsDataSystemNetworkType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.14

### qmi_wds_rat_3gpp2_build_string_from_mask ()

    gchar *
    qmi_wds_rat_3gpp2_build_string_from_mask
                                   (QmiWdsRat3gpp2 mask);

Builds a string containing a comma-separated list of nicknames for each QmiWdsRat3gpp2 in `mask` .

#### Parameters

mask | bitmask of QmiWdsRat3gpp2 values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### qmi_wds_rat_3gpp_build_string_from_mask ()

    gchar *
    qmi_wds_rat_3gpp_build_string_from_mask
                                   (QmiWdsRat3gpp mask);

Builds a string containing a comma-separated list of nicknames for each QmiWdsRat3gpp in `mask` .

#### Parameters

mask | bitmask of QmiWdsRat3gpp values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### qmi_wds_so_cdma1x_build_string_from_mask ()

    gchar *
    qmi_wds_so_cdma1x_build_string_from_mask
                                   (QmiWdsSoCdma1x mask);

Builds a string containing a comma-separated list of nicknames for each QmiWdsSoCdma1x in `mask` .

#### Parameters

mask | bitmask of QmiWdsSoCdma1x values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### qmi_wds_so_evdo_reva_build_string_from_mask ()

    gchar *
    qmi_wds_so_evdo_reva_build_string_from_mask
                                   (QmiWdsSoEvdoRevA mask);

Builds a string containing a comma-separated list of nicknames for each QmiWdsSoEvdoRevA in `mask` .

#### Parameters

mask | bitmask of QmiWdsSoEvdoRevA values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### qmi_wds_get_current_settings_requested_settings_get_string ()

    const gchar *
    qmi_wds_get_current_settings_requested_settings_get_string
                                   (QmiWdsGetCurrentSettingsRequestedSettings val);

Gets the nickname string for the QmiWdsGetCurrentSettingsRequestedSettings specified at `val` .

#### Parameters

val | a QmiWdsGetCurrentSettingsRequestedSettings. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_pdp_type_get_string ()

    const gchar *
    qmi_wds_pdp_type_get_string (QmiWdsPdpType val);

Gets the nickname string for the QmiWdsPdpType specified at `val` .

#### Parameters

val | a QmiWdsPdpType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_pdp_header_compression_type_get_string ()

    const gchar *
    qmi_wds_pdp_header_compression_type_get_string
                                   (QmiWdsPdpHeaderCompressionType val);

Gets the nickname string for the QmiWdsPdpHeaderCompressionType specified at `val` .

#### Parameters

val | a QmiWdsPdpHeaderCompressionType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_pdp_data_compression_type_get_string ()

    const gchar *
    qmi_wds_pdp_data_compression_type_get_string
                                   (QmiWdsPdpDataCompressionType val);

Gets the nickname string for the QmiWdsPdpDataCompressionType specified at `val` .

#### Parameters

val | a QmiWdsPdpDataCompressionType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_qos_class_identifier_get_string ()

    const gchar *
    qmi_wds_qos_class_identifier_get_string
                                   (QmiWdsQosClassIdentifier val);

Gets the nickname string for the QmiWdsQosClassIdentifier specified at `val` .

#### Parameters

val | a QmiWdsQosClassIdentifier. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_traffic_class_get_string ()

    const gchar *
    qmi_wds_traffic_class_get_string (QmiWdsTrafficClass val);

Gets the nickname string for the QmiWdsTrafficClass specified at `val` .

#### Parameters

val | a QmiWdsTrafficClass. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_authentication_build_string_from_mask ()

    gchar *
    qmi_wds_authentication_build_string_from_mask
                                   (QmiWdsAuthentication mask);

Builds a string containing a comma-separated list of nicknames for each QmiWdsAuthentication in `mask` .

#### Parameters

mask | bitmask of QmiWdsAuthentication values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### qmi_wds_profile_type_get_string ()

    const gchar *
    qmi_wds_profile_type_get_string (QmiWdsProfileType val);

Gets the nickname string for the QmiWdsProfileType specified at `val` .

#### Parameters

val | a QmiWdsProfileType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### qmi_wds_delivery_order_get_string ()

    const gchar *
    qmi_wds_delivery_order_get_string (QmiWdsDeliveryOrder val);

Gets the nickname string for the QmiWdsDeliveryOrder specified at `val` .

#### Parameters

val | a QmiWdsDeliveryOrder. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.14

### qmi_wds_sdu_error_ratio_get_string ()

    const gchar *
    qmi_wds_sdu_error_ratio_get_string (QmiWdsSduErrorRatio val);

Gets the nickname string for the QmiWdsSduErrorRatio specified at `val` .

#### Parameters

val | a QmiWdsSduErrorRatio. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.14

### qmi_wds_sdu_residual_bit_error_ratio_get_string ()

    const gchar *
    qmi_wds_sdu_residual_bit_error_ratio_get_string
                                   (QmiWdsSduResidualBitErrorRatio val);

Gets the nickname string for the QmiWdsSduResidualBitErrorRatio specified at `val` .

#### Parameters

val | a QmiWdsSduResidualBitErrorRatio. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.14

### qmi_wds_sdu_erroneous_delivery_get_string ()

    const gchar *
    qmi_wds_sdu_erroneous_delivery_get_string
                                   (QmiWdsSduErroneousDelivery val);

Gets the nickname string for the QmiWdsSduErroneousDelivery specified at `val` .

#### Parameters

val | a QmiWdsSduErroneousDelivery. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.14

### qmi_wds_packet_statistics_mask_flag_build_string_from_mask ()

    gchar *
    qmi_wds_packet_statistics_mask_flag_build_string_from_mask
                                   (QmiWdsPacketStatisticsMaskFlag mask);

Builds a string containing a comma-separated list of nicknames for each QmiWdsPacketStatisticsMaskFlag in `mask` .

#### Parameters

mask | bitmask of QmiWdsPacketStatisticsMaskFlag values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.6

### qmi_wds_ds_profile_error_get_string ()

    const gchar *
    qmi_wds_ds_profile_error_get_string (QmiWdsDsProfileError val);

Gets the nickname string for the QmiWdsDsProfileError specified at `val` .

#### Parameters

val | a QmiWdsDsProfileError. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.8

### qmi_wds_autoconnect_setting_get_string ()

    const gchar *
    qmi_wds_autoconnect_setting_get_string
                                   (QmiWdsAutoconnectSetting val);

Gets the nickname string for the QmiWdsAutoconnectSetting specified at `val` .

#### Parameters

val | a QmiWdsAutoconnectSetting. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.14

### qmi_wds_autoconnect_setting_roaming_get_string ()

    const gchar *
    qmi_wds_autoconnect_setting_roaming_get_string
                                   (QmiWdsAutoconnectSettingRoaming val);

Gets the nickname string for the QmiWdsAutoconnectSettingRoaming specified at `val` .

#### Parameters

val | a QmiWdsAutoconnectSettingRoaming. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.14

### qmi_wds_data_call_status_get_string ()

    const gchar *
    qmi_wds_data_call_status_get_string (QmiWdsDataCallStatus val);

Gets the nickname string for the QmiWdsDataCallStatus specified at `val` .

#### Parameters

val | a QmiWdsDataCallStatus. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_data_call_type_get_string ()

    const gchar *
    qmi_wds_data_call_type_get_string (QmiWdsDataCallType val);

Gets the nickname string for the QmiWdsDataCallType specified at `val` .

#### Parameters

val | a QmiWdsDataCallType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_data_system_get_string ()

    const gchar *
    qmi_wds_data_system_get_string (QmiWdsDataSystem val);

Gets the nickname string for the QmiWdsDataSystem specified at `val` .

#### Parameters

val | a QmiWdsDataSystem. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_dormancy_status_get_string ()

    const gchar *
    qmi_wds_dormancy_status_get_string (QmiWdsDormancyStatus val);

Gets the nickname string for the QmiWdsDormancyStatus specified at `val` .

#### Parameters

val | a QmiWdsDormancyStatus. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_extended_data_bearer_technology_3gpp2_get_string ()

    const gchar *
    qmi_wds_extended_data_bearer_technology_3gpp2_get_string
                                   (QmiWdsExtendedDataBearerTechnology3gpp2 val);

Gets the nickname string for the QmiWdsExtendedDataBearerTechnology3gpp2 specified at `val` .

#### Parameters

val | a QmiWdsExtendedDataBearerTechnology3gpp2. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_extended_data_bearer_technology_3gpp_get_string ()

    const gchar *
    qmi_wds_extended_data_bearer_technology_3gpp_get_string
                                   (QmiWdsExtendedDataBearerTechnology3gpp val);

Gets the nickname string for the QmiWdsExtendedDataBearerTechnology3gpp specified at `val` .

#### Parameters

val | a QmiWdsExtendedDataBearerTechnology3gpp. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_radio_access_technology_get_string ()

    const gchar *
    qmi_wds_radio_access_technology_get_string
                                   (QmiWdsRadioAccessTechnology val);

Gets the nickname string for the QmiWdsRadioAccessTechnology specified at `val` .

#### Parameters

val | a QmiWdsRadioAccessTechnology. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_set_event_report_transfer_statistics_get_string ()

    const gchar *
    qmi_wds_set_event_report_transfer_statistics_get_string
                                   (QmiWdsSetEventReportTransferStatistics val);

Gets the nickname string for the QmiWdsSetEventReportTransferStatistics specified at `val` .

#### Parameters

val | a QmiWdsSetEventReportTransferStatistics. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_so_evdo_rev0_get_string ()

    const gchar *
    qmi_wds_so_evdo_rev0_get_string (QmiWdsSoEvdoRev0 val);

Gets the nickname string for the QmiWdsSoEvdoRev0 specified at `val` .

#### Parameters

val | a QmiWdsSoEvdoRev0. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_so_evdo_revb_get_string ()

    const gchar *
    qmi_wds_so_evdo_revb_get_string (QmiWdsSoEvdoRevB val);

Gets the nickname string for the QmiWdsSoEvdoRevB specified at `val` .

#### Parameters

val | a QmiWdsSoEvdoRevB. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_tethered_call_type_get_string ()

    const gchar *
    qmi_wds_tethered_call_type_get_string (QmiWdsTetheredCallType val);

Gets the nickname string for the QmiWdsTetheredCallType specified at `val` .

#### Parameters

val | a QmiWdsTetheredCallType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_attach_pdn_list_action_get_string ()

    const gchar *
    qmi_wds_attach_pdn_list_action_get_string
                                   (QmiWdsAttachPdnListAction val);

Gets the nickname string for the QmiWdsAttachPdnListAction specified at `val` .

#### Parameters

val | a QmiWdsAttachPdnListAction. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.28

### qmi_wds_client_type_get_string ()

    const gchar *
    qmi_wds_client_type_get_string (QmiWdsClientType val);

Gets the nickname string for the QmiWdsClientType specified at `val` .

#### Parameters

val | a QmiWdsClientType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### qmi_wds_ip_support_type_get_string ()

    const gchar *
    qmi_wds_ip_support_type_get_string (QmiWdsIpSupportType val);

Gets the nickname string for the QmiWdsIpSupportType specified at `val` .

#### Parameters

val | a QmiWdsIpSupportType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.28

## Types and Values

### enum QmiWdsIpFamily

Type of IP family.

#### Members

QMI_WDS_IP_FAMILY_UNKNOWN | unknown. Since: 1.18. |
QMI_WDS_IP_FAMILY_IPV4 | IPv4. |
QMI_WDS_IP_FAMILY_IPV6 | IPv6. |
QMI_WDS_IP_FAMILY_UNSPECIFIED | None specified. |

Since: 1.0

### enum QmiWdsProfileFamily

Profile family.

#### Members

QMI_WDS_PROFILE_FAMILY_EMBEDDED | Embedded profile family. |
QMI_WDS_PROFILE_FAMILY_TETHERED | Tethered profile family. |

Since: 1.22

### enum QmiWdsTechnologyPreference

Type of network allowed when trying to connect.

#### Members

QMI_WDS_TECHNOLOGY_PREFERENCE_ALLOW_3GPP | 3GPP allowed. |
QMI_WDS_TECHNOLOGY_PREFERENCE_ALLOW_3GPP2 | 3GPP2 allowed. |

Since: 1.0

### enum QmiWdsExtendedTechnologyPreference

Type of network allowed when trying to connect.

#### Members

QMI_WDS_EXTENDED_TECHNOLOGY_PREFERENCE_CDMA | Use CDMA. |
QMI_WDS_EXTENDED_TECHNOLOGY_PREFERENCE_UMTS | Use UMTS. |
QMI_WDS_EXTENDED_TECHNOLOGY_PREFERENCE_EPC | Use EPC, LTE. |
QMI_WDS_EXTENDED_TECHNOLOGY_PREFERENCE_EMBMS | Use eMBMS. |
QMI_WDS_EXTENDED_TECHNOLOGY_PREFERENCE_MODEM_LINK_LOCAL | Use modem link-local. |

Since: 1.0

### enum QmiWdsCallType

Type of call to originate.

#### Members

QMI_WDS_CALL_TYPE_LAPTOP | Laptop call. |
QMI_WDS_CALL_TYPE_EMBEDDED | Embedded call. |

Since: 1.0

### enum QmiWdsCallEndReason

Reason for ending the call.

#### Members

QMI_WDS_CALL_END_REASON_GENERIC_UNSPECIFIED | Unspecified reason. |
QMI_WDS_CALL_END_REASON_GENERIC_CLIENT_END | Client end. |
QMI_WDS_CALL_END_REASON_GENERIC_NO_SERVICE | No service. |
QMI_WDS_CALL_END_REASON_GENERIC_FADE | Fade. |
QMI_WDS_CALL_END_REASON_GENERIC_RELEASE_NORMAL | Release normal. |
QMI_WDS_CALL_END_REASON_GENERIC_ACCESS_ATTEMPT_IN_PROGRESS | Access attempt in progress. |
QMI_WDS_CALL_END_REASON_GENERIC_ACCESS_FAILURE | Access Failure. |
QMI_WDS_CALL_END_REASON_GENERIC_REDIRECTION_OR_HANDOFF | Redirection or handoff. |
QMI_WDS_CALL_END_REASON_GENERIC_CLOSE_IN_PROGRESS | Close in progress. |
QMI_WDS_CALL_END_REASON_GENERIC_AUTHENTICATION_FAILED | Authentication failed. |
QMI_WDS_CALL_END_REASON_GENERIC_INTERNAL_ERROR | Internal error. |
QMI_WDS_CALL_END_REASON_CDMA_LOCK | CDMA specific. Phone is CDMA-locked. |
QMI_WDS_CALL_END_REASON_CDMA_INTERCEPT | CDMA specific. Received intercept from the BS. |
QMI_WDS_CALL_END_REASON_CDMA_REORDER | CDMA specific. Received reorder from the BS. |
QMI_WDS_CALL_END_REASON_CDMA_RELEASE_SO_REJECT | CDMA specific. Received release from the BS, SO reject. |
QMI_WDS_CALL_END_REASON_CDMA_INCOMING_CALL | CDMA specific. Received incoming call from the BS. |
QMI_WDS_CALL_END_REASON_CDMA_ALERT_STOP | CDMA specific. Received alert stop from the BS. |
QMI_WDS_CALL_END_REASON_CDMA_ACTIVATION | CDMA specific. Received end activation. |
QMI_WDS_CALL_END_REASON_CDMA_MAX_ACCESS_PROBES | CDMA specific. Maximum access probes transmitted. |
QMI_WDS_CALL_END_REASON_CDMA_CCS_NOT_SUPPORTED_BY_BS | CDMA specific. Concurrent service not supported by the BS. |
QMI_WDS_CALL_END_REASON_CDMA_NO_RESPONSE_FROM_BS | CDMA specific. No response received from the BS. |
QMI_WDS_CALL_END_REASON_CDMA_REJECTED_BY_BS | CDMA specific. Rejected by the BS. |
QMI_WDS_CALL_END_REASON_CDMA_INCOMPATIBLE | CDMA specific. Concurrent services requested are incompatible. |
QMI_WDS_CALL_END_REASON_CDMA_ALREADY_IN_TC | CDMA specific. Already in TC. |
QMI_WDS_CALL_END_REASON_CDMA_USER_CALL_ORIGINATED_DURING_GPS | CDMA specific. Call originated during GPS. |
QMI_WDS_CALL_END_REASON_CDMA_USER_CALL_ORIGINATED_DURING_SMS | CDMA specific. Call originated during SMS. |
QMI_WDS_CALL_END_REASON_CDMA_NO_SERVICE | CDMA specific. No service. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_CONFERENCE_FAILED | GSM/WCDMA specific. Call origination request failed. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_INCOMING_REJECTED | GSM/WCDMA specific. Client rejected incoming call. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_NO_SERVICE | GSM/WCDMA specific. No service. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_NETWORK_END | GSM/WCDMA specific. Network ended the call. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_LLC_SNDCP_FAILURE | GSM/WCDMA specific. LLC or SNDCP failure. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_INSUFFICIENT_RESOURCES | GSM/WCDMA specific. Insufficient resources. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_OPTION_TEMPORARILY_OUT_OF_ORDER | GSM/WCDMA specific. Service option temporarily out of order. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_NSAPI_ALREADY_USED | GSM/WCDMA specific. NSAPI already used. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_REGULAR_DEACTIVATION | GSM/WCDMA specific. Regular PDP context deactivation. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_NETWORK_FAILURE | GSM/WCDMA specific. Network failure. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_REATTACH_REQUIRED | GSM/WCDMA specific. Reattach required. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_PROTOCOL_ERROR | GSM/WCDMA specific. Protocol error. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_OPERATOR_DETERMINED_BARRING | GSM/WCDMA specific. Operator-determined barring. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_UNKNOWN_APN | GSM/WCDMA specific. Unknown or missing APN. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_UNKNOWN_PDP | GSM/WCDMA specific. Unknown PDP address or type. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_GGSN_REJECT | GSM/WCDMA specific. Activation rejected by GGSN. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_ACTIVATION_REJECT | GSM/WCDMA specific. Activation rejected. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_OPTION_NOT_SUPPORTED | GSM/WCDMA specific. Service option not supported. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_OPTION_UNSUBSCRIBED | GSM/WCDMA specific. Service option not subscribed. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_QOS_NOT_ACCEPTED | GSM/WCDMA specific. QoS not accepted. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_TFT_SEMANTIC_ERROR | GSM/WCDMA specific. Semantic error in TFT operation. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_TFT_SYNTAX_ERROR | GSM/WCDMA specific. Syntax error in TFT operation. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_UNKNOWN_PDP_CONTEXT | GSM/WCDMA specific. Unknown PDP context. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_FILTER_SEMANTIC_ERROR | GSM/WCDMA specific. Semantic error in packet filters. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_FILTER_SYNTAX_ERROR | GSM/WCDMA specific. Syntax error in packet filters. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_PDP_WITHOUT_ACTIVE_TFT | GSM/WCDMA specific. PDP context without TFT activated. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_INVALID_TRANSACTION_ID | GSM/WCDMA specific. Invalid transaction ID. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_MESSAGE_INCORRECT_SEMANTIC | GSM/WCDMA specific. Message incorrect semantically. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_INVALID_MANDATORY_INFO | GSM/WCDMA specific. Invalid mandatory information. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_MESSAGE_TYPE_UNSUPPORTED | GSM/WCDMA specific. Message type not implemented. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_MESSAGE_TYPE_NONCOMPATIBLE_STATE | GSM/WCDMA specific. Message not compatible with state. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_UNKNOWN_INFO_ELEMENT | GSM/WCDMA specific. Information element unknown. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_CONDITIONAL_IE_ERROR | GSM/WCDMA specific. Conditional IE error. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_MESSAGE_AND_PROTOCOL_STATE_UNCOMPATIBLE | GSM/WCDMA specific. Message and protocol state uncompatible. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_APN_TYPE_CONFLICT | GSM/WCDMA specific. APN type conflict. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_NO_GPRS_CONTEXT | GSM/WCDMA specific. No GPRS context. |
QMI_WDS_CALL_END_REASON_GSM_WCDMA_FEATURE_NOT_SUPPORTED | GSM/WCDMA specific. Feature not supported. |
QMI_WDS_CALL_END_REASON_EVDO_CONNECTION_DENY_GENERAL_OR_BUSY | CDMA/EVDO specific. Received Connection Deny: General or Network busy. |
QMI_WDS_CALL_END_REASON_EVDO_CONNECTION_DENY_BILLING_OR_AUTHENTICATION_FAILURE | CDMA/EVDO specific. Received Connection Deny: Billing or Authentication failure. |
QMI_WDS_CALL_END_REASON_EVDO_HDR_CHANGE | CDMA/EVDO specific. Change HDR. |
QMI_WDS_CALL_END_REASON_EVDO_HDR_EXIT | CDMA/EVDO specific. Exit HDR. |
QMI_WDS_CALL_END_REASON_EVDO_HDR_NO_SESSION | CDMA/EVDO specific. No HDR session. |
QMI_WDS_CALL_END_REASON_EVDO_HDR_ORIGINATION_DURING_GPS_FIX | CDMA/EVDO specific. HDR call ended in favor of a GPS fix. |
QMI_WDS_CALL_END_REASON_EVDO_HDR_CONNECTION_SETUP_TIMEOUT | CDMA/EVDO specific. Connection setup timeout. |
QMI_WDS_CALL_END_REASON_EVDO_HDR_RELEASED_BY_CM | CDMA/EVDO specific. Released HDR call by call manager. |

Since: 1.0

### enum QmiWdsVerboseCallEndReasonType

Type of verbose call end reason.

#### Members

QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_MIP | Mobile IP. |
QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_INTERNAL | Internal. |
QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_CM | Call manager. |
QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_3GPP | 3GPP. |
QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_PPP | PPP. |
QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_EHRPD | eHRPD. |
QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_IPV6 | IPv6. |

Since: 1.0

### enum QmiWdsVerboseCallEndReasonMip

Mobile IP specific call end reasons, given when the `QmiWdsVerboseCallEndReasonType` is QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_MIP.

#### Members

QMI_WDS_VERBOSE_CALL_END_REASON_MIP_ERROR_REASON_UNKNOWN | Unknown reason. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_REASON_UNSPECIFIED | FA error. Reason unspecified. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_ADMINISTRATIVELY_PROHIBITED | FA error. Administratively prohibited. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_INSUFFICIENT_RESOURCES | FA error. Insufficient resources. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_MOBILE_NODE_AUTHENTICATION_FAILURE | FA error. Mobile node authenticatin failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_HA_AUTHENTICATION_FAILURE | FA error. HA authentication failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_REQUESTED_LIFETIME_TOO_LONG | FA error. Requested lifetime too long. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_MALFORMED_REQUEST | FA error. Malformed request. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_MALFORMED_REPLY | FA error. Malformed reply. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_ENCAPSULATION_UNAVAILABLE | FA error. Encapsulation unavailable. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_VJHC_UNAVAILABLE | FA error. VJHC unavailable. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_REVERSE_TUNNEL_UNAVAILABLE | FA error. Reverse tunnel unavailable. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_REVERSE_TUNNEL_MANDATORY_AND_T_BIT_NOT_SET | FA error. Reverse tunnel mandatory and T bit not set. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_DELIVERY_STYLE_NOT_SUPPORTED | FA error. Delivery style not supported. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_MISSING_NAI | FA error. Missing NAI. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_MISSING_HA | FA error. Missing HA. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_MISSING_HOME_ADDRESS | FA error. Missing home address. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_UNKNOWN_CHALLENGE | FA error. Unknown challenge. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_MISSING_CHALLENGE | FA error. Missing challenge. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_FA_ERROR_STALE_CHALLENGE | FA error. Stale challenge. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_REASON_UNSPECIFIED | HA error. Reason unspecified. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_ADMINISTRATIVELY_PROHIBITED | HA error. Administratively prohibited. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_INSUFFICIENT_RESOURCES | HA error. Insufficient resources. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_MOBILE_NODE_AUTHENTICATION_FAILURE | HA error. Mobile node authentication failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_FA_AUTHENTICATION_FAILURE | HA error. FA authentication failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_REGISTRATION_ID_MISMATCH | HA error. Registration ID mismatch. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_MALFORMED_REQUEST | HA error. Malformed request. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_UNKNOWN_HA_ADDRESS | HA error. Unknown HA address. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_REVERSE_TUNNEL_UNAVAILABLE | HA error. Reverse tunnel unavailable. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_REVERSE_TUNNEL_MANDATORY_AND_T_BIT_NOT_SET | HA error. Reverse tunnel mandatory and T bit not set. |
QMI_WDS_VERBOSE_CALL_END_REASON_MIP_HA_ERROR_ENCAPSULATION_UNAVAILABLE | HA error. Encapsulation unavailable. |

Since: 1.0

### enum QmiWdsVerboseCallEndReasonInternal

Internal call end reasons, given when the `QmiWdsVerboseCallEndReasonType` is QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_INTERNAL.

#### Members

QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_ERROR | Internal error. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_CALL_ENDED | Call ended. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_UNKNOWN_INTERNAL_CAUSE | Unknown internal cause. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_UNKNOWN_CAUSE | Unknown cause. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_CLOSE_IN_PROGRESS | Close in progress. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_NETWORK_INITIATED_TERMINATION | Network initiated termination. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_APP_PREEMPTED | App preempted. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_PDN_IPV4_CALL_DISALLOWED | PDN IPv4 call disallowed. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_PDN_IPV4_CALL_THROTTLED | PDN IPv4 call throttled. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_PDN_IPV6_CALL_DISALLOWED | PDN IPv6 call disallowed. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_PDN_IPV6_CALL_THROTTLED | PDN IPv6 call throttled. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_MODEM_RESTART | Modem restart. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_PDP_PPP_NOT_SUPPORTED | PDP PPP not supported. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_UNPREFERRED_RAT | Unpreferred RAT. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_PHYSICAL_LINK_CLOSE_IN_PROGRESS | Physical link close in progress. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_APN_PENDING_HANDOVER | APN pending handover. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_PROFILE_BEARER_INCOMPATIBLE | Profile bearer incompatible. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_MMGDSI_CARD_EVENT | MMGDSI Card event. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_LPM_OR_POWER_DOWN | LPM or power down. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_APN_DISABLED | APN disabled. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_MPIT_EXPIRED | MPIT expired. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_IPV6_ADDRESS_TRANSFER_FAILED | IPv6 address transfer failed. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_TRAT_SWAP_FAILED | TRAT swap failed. Since: 1.14. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_EHRPD_TO_HRPD_FALLBACK | eHRPD to HRPD fallback. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_MANDATORY_APN_DISABLED | Mandatory APN disabled. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_MIP_CONFIG_FAILURE | MIP config failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_PDN_INACTIVITY_TIMER_EXPIRED | PDN inactivity timeout expired. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_MAX_V4_CONNECTIONS | Max IPv4 connections. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_MAX_V6_CONNECTIONS | Max IPv6 connections. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_APN_MISMATCH | APN mismatch. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_IP_VERSION_MISMATCH | IP version mismatch. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_DUN_CALL_DISALLOWED | DUN call disallowed. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_INVALID_PROFILE | Invalid profile. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_EPC_NONEPC_TRANSITION | EPC to non-EPC transition. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_INVALID_PROFILE_ID | Invalid profile ID. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_CALL_ALREADY_PRESENT | Call already present. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_INTERFACE_IN_USE | Interface in use. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_IP_PDP_MISMATCH | IP PDP mismatch. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_APN_DISALLOWED_ON_ROAMING | APN disallowed on roaming. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_APN_PARAMETER_CHANGE | APN parameter change. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_INTERFACE_IN_USE_CONFIG_MATCH | Interface in use config match. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_NULL_APN_DISALLOWED | NULL APN disallowed. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_THERMAL_MITIGATION | Thermal mitigation. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_SUBS_ID_MISMATCH | Subs ID mismatch Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_DATA_SETTINGS_DISABLED | Data settings disabled. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_DATA_ROAMING_SETTINGS_DISABLED | Data roaming settings disabled. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_APN_FORMAT_INVALID | APN format invalid. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_DDS_CALL_ABORT | DDS call abort. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_INTERNAL_VALIDATION_FAILURE | Validation failure. Since 1.24.10. |

Since: 1.0

### enum QmiWdsVerboseCallEndReasonCm

Call manager specific call end reasons, given when the `QmiWdsVerboseCallEndReasonType` is QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_CM.

#### Members

QMI_WDS_VERBOSE_CALL_END_REASON_CM_CDMA_LOCK | CDMA specific. Phone is CDMA-locked. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_INTERCEPT | CDMA specific. Received intercept from the BS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_REORDER | CDMA specific. Received reorder from the BS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_RELEASE_SO_REJECT | CDMA specific. Received release from the BS, SO reject. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_INCOMING_CALL | CDMA specific. Received incoming call from the BS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ALERT_STOP | CDMA specific. Received alert stop from the BS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ACTIVATION | CDMA specific. Received end activation. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_MAX_ACCESS_PROBES | CDMA specific. Maximum access probes transmitted. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_CCS_NOT_SUPPORTED_BY_BS | CDMA specific. Concurrent service not supported by the BS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NO_RESPONSE_FROM_BS | CDMA specific. No response received from the BS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_REJECTED_BY_BS | CDMA specific. Rejected by the BS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_INCOMPATIBLE | CDMA specific. Concurrent services requested are incompatible. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ALREADY_IN_TC | CDMA specific. Already in TC. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_USER_CALL_ORIGINATED_DURING_GPS | CDMA specific. Call originated during GPS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_USER_CALL_ORIGINATED_DURING_SMS | CDMA specific. Call originated during SMS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NO_CDMA_SERVICE | CDMA specific. No service. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_MC_ABORT | MC abort. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_PSIST_NG | Persistence test failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_UIM_NOT_PRESENT | UIM not present. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_RETRY_ORDER | Retry order. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ACCESS_BLOCK | Access blocked. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ACCESS_BLOCK_ALL | Access blocked for all. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_IS707B_MAX_ACCESS_PROBES | Maximum access probes for IS-707B call. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_THERMAL_EMERGENCY | Thermal emergency. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_CALL_ORIGINATION_THROTTLED | Call origination throttled. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_USER_CALL_ORIGINATED | Voice call originated and concurrent voice/data not supported. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_CONFERENCE_FAILED | Conference failed. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_INCOMING_REJECTED | Incoming rejected. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NO_GATEWAY_SERVICE | No gateway service. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NO_GPRS_CONTEXT | No GPRS context. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ILLEGAL_MS | Illegal MS. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ILLEGAL_ME | Illegal ME. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_GPRS_AND_NON_GPRS_SERVICES_NOT_ALLOWED | GPRS and non GPRS services not allowed. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_GPRS_SERVICES_NOT_ALLOWED | GPRS services not allowed. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_MS_IDENTITY_NOT_DERIVED_BY_THE_NETWORK | MS identity not derived by the network. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_IMPLICITLY_DETACHED | Implicitly detached. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_PLMN_NOT_ALLOWED | PLMN not allowed. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LA_NOT_ALLOWED | LA not allowed. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_GPRS_SERVICES_NOT_ALLOWED_IN_PLMN | GPRS services not allowed in PLMN. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_PDP_DUPLICATE | PDP duplicate. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_UE_RAT_CHANGE | UE radio access technology change. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_CONGESTION | Congestion. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NO_PDP_CONTEXT_ACTIVATED | No PDP context activated. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ACCESS_CLASS_DSAC_REJECTION | Access class DSAC rejection. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_PDP_ACTIVATE_MAX_RETRY_FAILED | Maximum retries failed to activate PDP context. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_RAB_FAILURE | RAB failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_EPS_SERVICE_NOT_ALLOWED | EPS service not allowed. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_TRACKING_AREA_NOT_ALLOWED | Tracking area not allowed. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ROAMING_NOT_ALLOWED_IN_TRACKING_AREA | Roaming not allowed in tracking area. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NO_SUITABLE_CELLS_IN_TRACKING_AREA | No suitable cells in tracking area. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NOT_AUTHORIZED_CLOSED_SUBSCRIBER_GROUP | Not authorized in closed subscriber group. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_UNKNOWN_EPS_BEARER_CONTEXT | EPS Session Management, unknown EPS bearer context. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_DRB_RELEASED_AT_RRC | DRB released at RRC. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NAS_SIGNAL_CONNECTION_RELEASED | NAS signal connection released. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_EMM_DETACHED | EPS Mobility Management, detached. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_EMM_ATTACH_FAILED | EPS Mobility Management, attach failed. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_EMM_ATTACH_STARTED | EPS Mobility Management, attach started. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LTE_NAS_SERVICE_REQUEST_FAILED | LTE NAS service request failed. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_ACTIVE_DEDICATED_BEARER_REACTIVATED_BY_NW | EPS Session Management, active dedicated bearer reactivated by network. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_LOWER_LAYER_FAILURE | EPS Session Management, lower layer failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_SYNC_UP_WITH_NW | EPS Session Management, sync up with network. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_NW_ACTIVATED_DEDICATED_BEARER_WITH_ID_OF_DEFAULT_BEARER | EPS Session Management, network activated dedicated bearer with id of default bearer. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_BAD_OTA_MESSAGE | EPS Session Management, bad OTA message. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_DS_REJECTED_CALL | EPS Session Management, DS rejected call. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_CONTEXT_TRANSFERRED_DUE_TO_IRAT | EPS Session Management, context transferred due to IRAT. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_DS_EXPLICIT_DEACT | DS explicit deactivation. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_LOCAL_CAUSE_NONE | EPS Session Management, local cause none. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LTE_NAS_SERVICE_REQUEST_FAILED_NO_THROTTLE | LTE NAS service request failed, no throttle. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ACL_FAILURE | ACL failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LTE_NAS_SERVICE_REQUEST_FAILED_DS_DISALLOW | LTE NAS service request failed, DS disallow. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_EMM_T3417_EXPIRED | EPS Mobility Management, T3417 expired. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_EMM_T3417_EXT_EXPIRED | EPS Mobility Management, T3417 ext expired. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_UL_DATA_CONFIRMATION_FAILURE_TXN | LTE Radio Resource Control, UL data confirmation failure, txn. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_UL_DATA_CONFIRMATION_FAILURE_HANDOVER | LTE Radio Resource Control, UL data confirmation failure, handover. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_UL_DATA_CONFIRMATION_FAILURE_CONN_REL | LTE Radio Resource Control, UL data confirmation failure, connection release. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_UL_DATA_CONFIRMATION_FAILURE_RLF | LTE Radio Resource Control, UL data confirmation failure, radio link failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_UL_DATA_CONFIRMATION_FAILURE_CTRL_NOT_CONN | LTE Radio Resource Control, UL data confirmation failure, ctrl not conn. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE | LTE Radio Resource Control, connection establishment failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE_ABORTED | LTE Radio Resource Control, connection establishment failure, aborted. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE_ACCESS_BARRED | LTE Radio Resource Control, connection establishment failure, access barred. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE_CELL_RESELECTION | LTE Radio Resource Control, connection establishment failure, cell reselection. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE_CONFIG_FAILURE | LTE Radio Resource Control, connection establishment failure, config failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE_TIMER_EXPIRED | LTE Radio Resource Control, connection establishment failure, timer expired. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE_LINK_FAILURE | LTE Radio Resource Control, connection establishment failure, link failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE_NOT_CAMPED | LTE Radio Resource Control, connection establishment failure, not camped. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE_SI_FAILURE | LTE Radio Resource Control, connection establishment failure, SI failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_ESTABLISHMENT_FAILURE_REJECTED | LTE Radio Resource Control, connection establishment failure, rejected. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_RELEASE_NORMAL | LTE Radio Resource Control, connection release, normal. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_RELEASE_RLF | LTE Radio Resource Control, connection release, radio link failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_RELEASE_CRE_FAILURE | LTE Radio Resource Control, connection release, cre failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_RELEASE_OOS_DURING_CRE | LTE Radio Resource Control, connection release, oos during cre. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_RELEASE_ABORTED | LTE Radio Resource Control, connection release, aborted. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_LRRC_CONNECTION_RELEASE_SIB_READ_ERROR | LTE Radio Resource Control, connection release, SIB read error. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_DETACH_WITH_REATTACH_LTE_NW_DETACH | Detach with reattach LTE network detach. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_DETACH_WITHOUT_REATTACH_LTE_NW_DETACH | Detach without reattach LTE network detach. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ESM_PROC_TIMEOUT | EPS Session Management, proc timeout. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_MESSAGE_EXCEED_MAX_L2_LIMIT | Message exceed max L2 limit. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_CONNECTION_DENY_GENERAL_OR_BUSY | CDMA/EVDO specific. Received Connection Deny. General or Network busy. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_CONNECTION_DENY_BILLING_OR_AUTHENTICATION_FAILURE | CDMA/EVDO specific. Received Connection Deny. Billing or Authentication failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_CHANGE | CDMA/EVDO specific. Change HDR. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_EXIT | CDMA/EVDO specific. Exit HDR. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_NO_SESSION | CDMA/EVDO specific. No HDR session. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_ORIGINATION_DURING_GPS_FIX | CDMA/EVDO specific. HDR call ended in favor of a GPS fix. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_CONNECTION_SETUP_TIMEOUT | CDMA/EVDO specific. Connection setup timeout. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_RELEASED_BY_CM | CDMA/EVDO specific. Released HDR call by call manager. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_COLLOCATED_ACQUISITION_FAILED | Failed to acquire co-located HDR for origination. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_OTASP_COMMIT_IN_PROGRESS | CDMA/EVDO specific. OTASP commit in progress. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_NO_HYBRID_SERVICE | CDMA/EVDO specific. No hybrid HDR service. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_NO_LOCK_GRANTED | CDMA/EVDO specific. No lock granted. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HOLD_OTHER_IN_PROGRESS | CDMA/EVDO specific. hold other in progress. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_FADE | CDMA/EVDO specific. Fade. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_HDR_ACCESS_FAILURE | CDMA/EVDO specific. Access failure. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_CLIENT_END | Client end. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NO_SERVICE | No service. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_FADE | Fade. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_RELEASE_NORMAL | Release normal. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ACCESS_ATTEMPT_IN_PROGRESS | Access attempt in progress. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_ACCESS_FAILURE | Access Failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_REDIRECTION_OR_HANDOFF | Redirection or handoff. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_OFFLINE | Offline. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_EMERGENCY_MODE | Emergency mode. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_PHONE_IN_USE | Phone in use. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_INVALID_MODE | Invalid mode. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_INVALID_SIM_STATE | Invalid SIM state. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_NO_COLLOCATED_HDR | No collocated HDR. Since 1.24.10. |
QMI_WDS_VERBOSE_CALL_END_REASON_CM_CALL_CONTROL_REJECTED | Call control rejected. Since 1.24.10. |

Since: 1.0

### enum QmiWdsVerboseCallEndReason3gpp

3GPP-specific call end reasons, given when the `QmiWdsVerboseCallEndReasonType` is QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_3GPP.

#### Members

QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_OPERATOR_DETERMINED_BARRING | Operator-determined barring. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_LLC_SNDCP_FAILURE | LLC or SNDCP failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_INSUFFICIENT_RESOURCES | Insufficient resources. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_UNKNOWN_APN | Unknown or missing APN. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_UNKNOWN_PDP | Unknown PDP address or type. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_AUTHENTICATION_FAILED | Authentication failed. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_GGSN_REJECT | Activation rejected by GGSN. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_ACTIVATION_REJECT | Activation rejected. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_OPTION_NOT_SUPPORTED | Service option not supported. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_OPTION_UNSUBSCRIBED | Service option not subscribed. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_OPTION_TEMPORARILY_OUT_OF_ORDER | Service option temporarily out of order. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_NSAPI_ALREADY_USED | NSAPI already used. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_REGULAR_DEACTIVATION | Regular PDP context deactivation. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_QOS_NOT_ACCEPTED | QoS not accepted. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_NETWORK_FAILURE | Network failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_REATTACH_REQUIRED | Reattach required. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_FEATURE_NOT_SUPPORTED | Feature not supported. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_TFT_SEMANTIC_ERROR | Semantic error in TFT operation. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_TFT_SYNTAX_ERROR | Syntax error in TFT operation. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_UNKNOWN_PDP_CONTEXT | Unknown PDP context. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_FILTER_SEMANTIC_ERROR | Semantic error in packet filters. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_FILTER_SYNTAX_ERROR | Syntax error in packet filters. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_PDP_WITHOUT_ACTIVE_TFT | PDP context without TFT activated. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_IPV4_ONLY_ALLOWED | IPv4 only allowed. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_IPV6_ONLY_ALLOWED | IPv6 only allowed. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_SINGLE_ADDRESS_BEARER_ONLY | Single address bearer only. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_ESM_INFO_NOT_RECEIVED | ESM information not received. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_PDN_CONNECTION_DOES_NOT_EXIST | PDN connection does not exist. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_MULTIPLE_CONNECTION_TO_SAME_PDN_NOT_ALLOWED | Multiple connection to same PDN not allowed. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_INVALID_TRANSACTION_ID | Invalid transaction ID. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_MESSAGE_INCORRECT_SEMANTIC | Message incorrect semantically. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_INVALID_MANDATORY_INFO | Invalid mandatory information. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_MESSAGE_TYPE_UNSUPPORTED | Message type not implemented. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_MESSAGE_TYPE_NONCOMPATIBLE_STATE | Message not compatible with state. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_UNKNOWN_INFO_ELEMENT | Information element unknown. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_CONDITIONAL_IE_ERROR | Conditional IE error. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_MESSAGE_AND_PROTOCOL_STATE_UNCOMPATIBLE | Message and protocol state uncompatible. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_PROTOCOL_ERROR | Protocol error. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_APN_TYPE_CONFLICT | APN type conflict. |
QMI_WDS_VERBOSE_CALL_END_REASON_3GPP_INVALID_PROXY_CALL_SESSION_CONTROL_FUNCTION_ADDRESS | Invalid proxy call session control function address. Since 1.24.10. |

Since: 1.0

### enum QmiWdsVerboseCallEndReasonPpp

PPP-specific call end reasons, given when the `QmiWdsVerboseCallEndReasonType` is QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_PPP.

#### Members

QMI_WDS_VERBOSE_CALL_END_REASON_PPP_UNKNOWN | Unknown error. |
QMI_WDS_VERBOSE_CALL_END_REASON_PPP_TIMEOUT | Timeout. |
QMI_WDS_VERBOSE_CALL_END_REASON_PPP_AUTHENTICATION_FAILURE | Authentication failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_PPP_OPTION_MISMATCH | Option mismatch. |
QMI_WDS_VERBOSE_CALL_END_REASON_PPP_PAP_FAILURE | PAP failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_PPP_CHAP_FAILURE | CHAP failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_PPP_CLOSE_IN_PROGRESS | Close in progress. Since 1.24.10. |

Since: 1.0

### enum QmiWdsVerboseCallEndReasonEhrpd

eHRPD-specific call end reasons, given when the `QmiWdsVerboseCallEndReasonType` is QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_EHRPD.

#### Members

QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_SUBSCRIPTION_LIMITED_TO_IPV4 | Subscription limited to IPv4. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_SUBSCRIPTION_LIMITED_TO_IPV6 | Subscription limited to IPv6. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_TIMEOUT | VSNCP specific. timeout. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_FAILURE | VSNCP specific. failure. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_GENERAL_ERROR | VSNCP specific. 3GPP2 general error. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_UNAUTHENTICATED_APN | VSNCP specific. 3GPP2 unauthenticated APN. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_PDN_LIMIT_EXCEEDED | VSNCP specific. 3GPP2 PDN limit exceeded. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_NO_PDN_GATEWAY | VSNCP specific. 3GPP2 no PDN gateway. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_PDN_GATEWAY_UNREACHABLE | VSNCP specific. 3GPP2 PDN gateway unreachable. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_PDN_GATEWAY_REJECTED | VSNCP specific. 3GPP2 PDN gateway rejected. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_INSUFFICIENT_PARAMETERS | VSNCP specific. 3GPP2 insufficient parameters. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_RESOURCE_UNAVAILABLE | VSNCP specific. 3GPP2 resource unavailable. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_ADMINISTRATIVELY_PROHIBITED | VSNCP specific. 3GPP2 administratively prohibited. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_PDN_ID_IN_USE | VSNCP specific. 3GPP2 PDN ID in use. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_SUBSCRIPTION_LIMITATION | VSNCP specific. 3GPP2 subscription limitation. |
QMI_WDS_VERBOSE_CALL_END_REASON_EHRPD_VSNCP_3GPP2_PDN_EXISTS_FOR_THIS_APN | VSNCP specific. 3GPP2 PDN exists for this APN. |

Since: 1.0

### enum QmiWdsVerboseCallEndReasonIpv6

IPv6-specific call end reasons, given when the `QmiWdsVerboseCallEndReasonType` is QMI_WDS_VERBOSE_CALL_END_REASON_TYPE_IPV6.

#### Members

QMI_WDS_VERBOSE_CALL_END_REASON_IPV6_PREFIX_UNAVAILABLE | Prefix unavailable. |
QMI_WDS_VERBOSE_CALL_END_REASON_IPV6_HRPD_IPV6_DISABLED | HRDP IPv6 disabled. |
QMI_WDS_VERBOSE_CALL_END_REASON_IPV6_DISABLED | IPv6 disabled. Since 1.24.10. |

Since: 1.0

### enum QmiWdsConnectionStatus

Status of the network connection.

#### Members

QMI_WDS_CONNECTION_STATUS_UNKNOWN | Unknown status. |
QMI_WDS_CONNECTION_STATUS_DISCONNECTED | Network is disconnected |
QMI_WDS_CONNECTION_STATUS_CONNECTED | Network is connected. |
QMI_WDS_CONNECTION_STATUS_SUSPENDED | Network connection is suspended. |
QMI_WDS_CONNECTION_STATUS_AUTHENTICATING | Network authentication is ongoing. |

Since: 1.0

### enum QmiWdsDataBearerTechnology

Data bearer technology.

#### Members

QMI_WDS_DATA_BEARER_TECHNOLOGY_UNKNOWN | Unknown. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_CDMA20001X | CDMA2000 1x. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_1xEVDO | CDMA2000 HRPD 1xEVDO. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_GSM | GSM. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_UMTS | UMTS. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_1xEVDO_REVA | CDMA2000 HRPD 1xEVDO RevA. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_EDGE | EDGE. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_HSDPA | HSDPA and WCDMA. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_HSUPA | WCDMA and HSUPA. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_HSDPA_HSUPDA | HSDPA and HSUPA. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_LTE | LTE. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_EHRPD | CDMA2000 eHRPD. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_HSDPAPLUS | HSDPA+ and WCDMA. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_HSDPAPLUS_HSUPA | HSDPA+ and HSUPA. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_DCHSDPAPLUS | DC-HSDPA+ and WCDMA. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_DCHSDPAPLUS_HSUPA | DC-HSDPA+ and HSUPA. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_HSDPAPLUS_PLUS_64QAM | HSDPA+ with 64QAM. Since: 1.18. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_HSDPAPLUS_PLUS_64QAM_HSUPA | HSDPA+ with 64QAM and HSUPA. Since: 1.18. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_TDSCDMA | TD-SCDMA. Since: 1.18. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_TDSCDMA_HSDPA | TD-SCDMA and HSDPA. Since: 1.18. |
QMI_WDS_DATA_BEARER_TECHNOLOGY_TDSCDMA_HSUPA | TD-SCDMA and HSUPA. Since: 1.18. |

Since: 1.0

### enum QmiWdsNetworkType

Network type of the data bearer.

#### Members

QMI_WDS_NETWORK_TYPE_UNKNOWN | Unknown. |
QMI_WDS_NETWORK_TYPE_3GPP2 | 3GPP2 network type. |
QMI_WDS_NETWORK_TYPE_3GPP | 3GPP network type. |

Since: 1.0

### enum QmiWdsDataSystemNetworkType

Network type of the data system.

#### Members

QMI_WDS_DATA_SYSTEM_NETWORK_TYPE_3GPP | 3GPP network type. |
QMI_WDS_DATA_SYSTEM_NETWORK_TYPE_3GPP2 | 3GPP2 network type. |

Since: 1.14

### enum QmiWdsRat3gpp2

Flags specifying the 3GPP2-specific Radio Access Technology, when the data bearer network type is `QMI_WDS_NETWORK_TYPE_3GPP2` .

#### Members

QMI_WDS_RAT_3GPP2_NONE | Unknown, to be ignored. |
QMI_WDS_RAT_3GPP2_CDMA1X | CDMA 1x. |
QMI_WDS_RAT_3GPP2_EVDO_REV0 | EVDO Rev0. |
QMI_WDS_RAT_3GPP2_EVDO_REVA | EVDO RevA. |
QMI_WDS_RAT_3GPP2_EVDO_REVB | EVDO RevB. |
QMI_WDS_RAT_3GPP2_EHRPD | eHRPD. Since: 1.18. |
QMI_WDS_RAT_3GPP2_FMC | FMC. Since: 1.18. |
QMI_WDS_RAT_3GPP2_NULL_BEARER | No bearer. |

Since: 1.0

### enum QmiWdsRat3gpp

Flags specifying the 3GPP-specific Radio Access Technology, when the data bearer network type is `QMI_WDS_NETWORK_TYPE_3GPP` .

#### Members

QMI_WDS_RAT_3GPP_NONE | Unknown, to be ignored. |
QMI_WDS_RAT_3GPP_WCDMA | WCDMA. |
QMI_WDS_RAT_3GPP_GPRS | GPRS. |
QMI_WDS_RAT_3GPP_HSDPA | HSDPA. |
QMI_WDS_RAT_3GPP_HSUPA | HSUPA. |
QMI_WDS_RAT_3GPP_EDGE | EDGE. |
QMI_WDS_RAT_3GPP_LTE | LTE. |
QMI_WDS_RAT_3GPP_HSDPAPLUS | HSDPA+. |
QMI_WDS_RAT_3GPP_DCHSDPAPLUS | DC-HSDPA+. |
QMI_WDS_RAT_3GPP_64QAM | 64QAM. Since: 1.18. |
QMI_WDS_RAT_3GPP_TDSCDMA | TD-SCDMA. Since: 1.18. |
QMI_WDS_RAT_3GPP_NULL_BEARER | No bearer. |

Since: 1.0

### enum QmiWdsSoCdma1x

Flags specifying the Service Option when the bearer network type is `QMI_WDS_NETWORK_TYPE_3GPP2` and when the Radio Access Technology mask contains `QMI_WDS_RAT_3GPP2_CDMA1X` .

#### Members

QMI_WDS_SO_CDMA1X_NONE | Unknown, to be ignored. |
QMI_WDS_SO_CDMA1X_IS95 | IS95. |
QMI_WDS_SO_CDMA1X_IS2000 | IS2000. |
QMI_WDS_SO_CDMA1X_IS2000_REL_A | IS2000 RelA. |

Since: 1.0

### enum QmiWdsSoEvdoRevA

Flags specifying the Service Option when the bearer network type is `QMI_WDS_NETWORK_TYPE_3GPP2` and when the Radio Access Technology mask contains `QMI_WDS_RAT_3GPP2_EVDO_REVA` .

#### Members

QMI_WDS_SO_EVDO_REVA_NONE | Unknown, to be ignored. |
QMI_WDS_SO_EVDO_REVA_DPA | DPA. |
QMI_WDS_SO_EVDO_REVA_MFPA | MFPA. |
QMI_WDS_SO_EVDO_REVA_EMPA | EMPA. |
QMI_WDS_SO_EVDO_REVA_EMPA_EHRPD | EMPA eHRPD. |

Since: 1.0

### enum QmiWdsGetCurrentSettingsRequestedSettings

Flags specifying which specific settings to return when requesting the current WDS bearer settings.

#### Members

QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_NONE | no settings requested |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_PROFILE_ID | request profile ID |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_PROFILE_NAME | request profile name |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_PDP_TYPE | request PDP context type |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_APN_NAME | request APN name |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_DNS_ADDRESS | request DNS server addresses |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_GRANTED_QOS | request granted QoS |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_USERNAME | request username |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_AUTH_PROTOCOL | request authentication protocol, ie PAP/CHAP/none. |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_IP_ADDRESS | request IP address |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_GATEWAY_INFO | request gateway address |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_PCSCF_ADDRESS | request PCSCF address |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_PCSCF_SERVER_ADDRESS_LIST | request PCSCF server address list |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_PCSCF_DOMAIN_NAME_LIST | request PCSCF domain name list |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_MTU | request MTU |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_DOMAIN_NAME_LIST | request domain name list |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_IP_FAMILY | request IP family, ie IPv4 or IPv6. |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_IMCN_FLAG | request IMCN flag |
QMI_WDS_GET_CURRENT_SETTINGS_REQUESTED_SETTINGS_EXTENDED_TECHNOLOGY | request extended technology info |

Since: 1.0

### enum QmiWdsPdpType

PDP context type.

#### Members

QMI_WDS_PDP_TYPE_IPV4 | IPv4 |
QMI_WDS_PDP_TYPE_PPP | PPP |
QMI_WDS_PDP_TYPE_IPV6 | IPv6 |
QMI_WDS_PDP_TYPE_IPV4_OR_IPV6 | IPv4 and IPv6 combined context |

Since: 1.0

### enum QmiWdsPdpHeaderCompressionType

PDP header compression types.

#### Members

QMI_WDS_PDP_HEADER_COMPRESSION_TYPE_OFF | no header compression |
QMI_WDS_PDP_HEADER_COMPRESSION_TYPE_MANUFACTURER_PREFERRED | manufacturer preferred |
QMI_WDS_PDP_HEADER_COMPRESSION_TYPE_RFC1144 | RFC1144 |
QMI_WDS_PDP_HEADER_COMPRESSION_TYPE_RFC2507 | RFC2507 |
QMI_WDS_PDP_HEADER_COMPRESSION_TYPE_RFC3095 | RFC3095 |

Since: 1.18

### enum QmiWdsPdpDataCompressionType

PDP data compression types.

#### Members

QMI_WDS_PDP_DATA_COMPRESSION_TYPE_OFF | no data compression |
QMI_WDS_PDP_DATA_COMPRESSION_TYPE_MANUFACTURER_PREFERRED | manufacturer preferred |
QMI_WDS_PDP_DATA_COMPRESSION_TYPE_V42BIS | V42bis |
QMI_WDS_PDP_DATA_COMPRESSION_TYPE_V44 | V44 |

Since: 1.18

### enum QmiWdsQosClassIdentifier

QoS Class Identifier.

#### Members

QMI_WDS_QOS_CLASS_IDENTIFIER_NETWORK_ASSIGN | network assigned |
QMI_WDS_QOS_CLASS_IDENTIFIER_GUARANTEED_BITRATE1 | guaranteed bitrate 1 |
QMI_WDS_QOS_CLASS_IDENTIFIER_GUARANTEED_BITRATE2 | guaranteed bitrate 2 |
QMI_WDS_QOS_CLASS_IDENTIFIER_GUARANTEED_BITRATE3 | guaranteed bitrate 3 |
QMI_WDS_QOS_CLASS_IDENTIFIER_GUARANTEED_BITRATE4 | guaranteed bitrate 4 |
QMI_WDS_QOS_CLASS_IDENTIFIER_NON_GUARANTEED_BITRATE5 | non-guaranteed bitrate 5 |
QMI_WDS_QOS_CLASS_IDENTIFIER_NON_GUARANTEED_BITRATE6 | non-guaranteed bitrate 6 |
QMI_WDS_QOS_CLASS_IDENTIFIER_NON_GUARANTEED_BITRATE7 | non-guaranteed bitrate 7 |
QMI_WDS_QOS_CLASS_IDENTIFIER_NON_GUARANTEED_BITRATE8 | non-guaranteed bitrate 8 |

Since: 1.18

### enum QmiWdsTrafficClass

QoS Traffic Classes.

#### Members

QMI_WDS_TRAFFIC_CLASS_SUBSCRIBED | default class, best-effort |
QMI_WDS_TRAFFIC_CLASS_CONVERSATIONAL | two-way video/voice, most delay sensitive |
QMI_WDS_TRAFFIC_CLASS_STREAMING | one-way video/audio, delay sensitive |
QMI_WDS_TRAFFIC_CLASS_INTERACTIVE | delay-sensitive, e.g. browsing, SSH. |
QMI_WDS_TRAFFIC_CLASS_BACKGROUND | delay-insensitive, e.g. downloads, email. |

Since: 1.0

### enum QmiWdsAuthentication

PDP context authentication protocols.

#### Members

QMI_WDS_AUTHENTICATION_NONE | no authentication |
QMI_WDS_AUTHENTICATION_PAP | PAP authentication |
QMI_WDS_AUTHENTICATION_CHAP | CHAP authentication |

Since: 1.0

### enum QmiWdsProfileType

Profile network type family.

#### Members

QMI_WDS_PROFILE_TYPE_3GPP | 3GPP profile type. |
QMI_WDS_PROFILE_TYPE_3GPP2 | 3GPP2 profile type. |

Since: 1.0

### enum QmiWdsDeliveryOrder

QoS delivery order.

#### Members

QMI_WDS_QOS_DELIVERY_ORDER_SUBSCRIBE | Subscribe. |
QMI_WDS_QOS_DELIVERY_ORDER_ON | On. |
QMI_WDS_QOS_DELIVERY_ORDER_OFF | Off. |

Since: 1.14

### enum QmiWdsSduErrorRatio

Target value for the fraction of SDUs lost or detected as erroneous.

#### Members

QMI_WDS_SDU_ERROR_RATIO_SUBSCRIBE | Subscribe. |
QMI_WDS_SDU_ERROR_RATIO_1E2 | 1x10^2. |
QMI_WDS_SDU_ERROR_RATIO_7E3 | 7x10^3. |
QMI_WDS_SDU_ERROR_RATIO_1E3 | 1x10^3. |
QMI_WDS_SDU_ERROR_RATIO_1E4 | 1x10^4. |
QMI_WDS_SDU_ERROR_RATIO_1E5 | 1x10^5. |
QMI_WDS_SDU_ERROR_RATIO_1E6 | 1x10^6. |
QMI_WDS_SDU_ERROR_RATIO_1E1 | 1x10^7. |

Since: 1.14

### enum QmiWdsSduResidualBitErrorRatio

Target value for the undetected bit error ratio in the delivered SDUs.

#### Members

QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_SUBSCRIBE | Subscribe. |
QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_5E2 | 5x10^2. |
QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_1E2 | 1x10^2. |
QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_5E3 | 5x10^3. |
QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_4E3 | 4x10^3. |
QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_1E3 | 1x10^3. |
QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_1E4 | 1x10^4. |
QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_1E5 | 1x10^5. |
QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_1E6 | 1x10^6. |
QMI_WDS_SDU_RESIDUAL_BIT_ERROR_RATIO_6E8 | 6x10^8. |

Since: 1.14

### enum QmiWdsSduErroneousDelivery

Whether SDUs detected as erroneous are delivered or not.

#### Members

QMI_WDS_SDU_ERRONEOUS_DELIVERY_SUBSCRIBE | Subscribe. |
QMI_WDS_SDU_ERRONEOUS_DELIVERY_NO_DETECTION | No detection. |
QMI_WDS_SDU_ERRONEOUS_DELIVERY_ENABLED | Erroneous SDUs are delivered. |
QMI_WDS_SDU_ERRONEOUS_DELIVERY_DISABLED | Erroneous SDUs are delivered. |

Since: 1.14

### enum QmiWdsPacketStatisticsMaskFlag

Mask to use when requesting packet statistics.

#### Members

QMI_WDS_PACKET_STATISTICS_MASK_FLAG_TX_PACKETS_OK | Request count of correctly sent packets. |
QMI_WDS_PACKET_STATISTICS_MASK_FLAG_RX_PACKETS_OK | Request count of correctly received packets. |
QMI_WDS_PACKET_STATISTICS_MASK_FLAG_TX_PACKETS_ERROR | Request count of sent packets with error. |
QMI_WDS_PACKET_STATISTICS_MASK_FLAG_RX_PACKETS_ERROR | Request count of received packets with error. |
QMI_WDS_PACKET_STATISTICS_MASK_FLAG_TX_OVERFLOWS | Request count of transmitter overflows. |
QMI_WDS_PACKET_STATISTICS_MASK_FLAG_RX_OVERFLOWS | Request count of receiver overflows. |
QMI_WDS_PACKET_STATISTICS_MASK_FLAG_TX_BYTES_OK | Request count of correctly sent bytes. |
QMI_WDS_PACKET_STATISTICS_MASK_FLAG_RX_BYTES_OK | Request count of correctly received bytes. |
QMI_WDS_PACKET_STATISTICS_MASK_FLAG_TX_PACKETS_DROPPED | Request count of dropped packets in transmission. |
QMI_WDS_PACKET_STATISTICS_MASK_FLAG_RX_PACKETS_DROPPED | Request count of dropped packets in reception. |

Since: 1.6

### enum QmiWdsDsProfileError

Extended DS profile errors.

#### Members

QMI_WDS_DS_PROFILE_ERROR_UNKNOWN | Unknown DS profile error. |
QMI_WDS_DS_PROFILE_ERROR_FAIL | General failure. |
QMI_WDS_DS_PROFILE_ERROR_INVALID_HANDLE | Invalid handle. |
QMI_WDS_DS_PROFILE_ERROR_INVALID_OPERATION | Invalid operation. |
QMI_WDS_DS_PROFILE_ERROR_INVALID_PROFILE_TYPE | Invalid profile type. |
QMI_WDS_DS_PROFILE_ERROR_INVALID_PROFILE_NUMBER | Invalid profile number. |
QMI_WDS_DS_PROFILE_ERROR_INVALID_PROFILE_ID | Invalid profile identifier. |
QMI_WDS_DS_PROFILE_ERROR_INVALID_ARGUMENT | Invalid argument. |
QMI_WDS_DS_PROFILE_ERROR_REGISTRY_NOT_INITIALIZED | Registry not initialized. |
QMI_WDS_DS_PROFILE_ERROR_INVALID_PARAMETER_LENGTH | Invalid parameter length. |
QMI_WDS_DS_PROFILE_ERROR_LIST_END | List end, profile not found. |
QMI_WDS_DS_PROFILE_ERROR_INVALID_SUBSCRIPTION_ID | Invalid subscription identifier. |
QMI_WDS_DS_PROFILE_ERROR_INVALID_PROFILE_FAMILY | Invalid profile family. |
QMI_WDS_DS_PROFILE_ERROR_3GPP_INVALID_PROFILE_FAMILY | Invalid 3GPP profile family. |
QMI_WDS_DS_PROFILE_ERROR_3GPP_ACCESS_ERROR | Error accessing 3GPP profiles. |
QMI_WDS_DS_PROFILE_ERROR_3GPP_CONTEXT_NOT_DEFINED | 3GPP profile doesn't have a valid context. |
QMI_WDS_DS_PROFILE_ERROR_3GPP_VALID_FLAG_NOT_SET | 3GPP profile doesn't have valid flag set. |
QMI_WDS_DS_PROFILE_ERROR_3GPP_READ_ONLY_FLAG_SET | 3GPP profile has read-only flag set. |
QMI_WDS_DS_PROFILE_ERROR_3GPP_OUT_OF_PROFILES | Out of 3GPP profiles. |
QMI_WDS_DS_PROFILE_ERROR_3GPP2_INVALID_PROFILE_ID | Invalid 3GPP2 profile identifier. |

Since: 1.8

### enum QmiWdsAutoconnectSetting

Status of the autoconnect setting.

#### Members

QMI_WDS_AUTOCONNECT_SETTING_DISABLED | Disabled. |
QMI_WDS_AUTOCONNECT_SETTING_ENABLED | Enabled. |
QMI_WDS_AUTOCONNECT_SETTING_PAUSED | Paused, resume on power cycle. |

Since: 1.14

### enum QmiWdsAutoconnectSettingRoaming

Status of the autoconnect setting while roaming.

#### Members

QMI_WDS_AUTOCONNECT_SETTING_ROAMING_ALLOWED | Autoconnect always allowed, even when roaming. |
QMI_WDS_AUTOCONNECT_SETTING_ROAMING_HOME_ONLY | Autoconnect allowed only in home network. |

Since: 1.14

### enum QmiWdsDataCallStatus

Data call status.

#### Members

QMI_WDS_DATA_CALL_STATUS_UNKNOWN | data call status unknown. |
QMI_WDS_DATA_CALL_STATUS_ACTIVATED | data call status activated. |
QMI_WDS_DATA_CALL_STATUS_TERMINATED | data call status terminated. |

Since: 1.18

### enum QmiWdsDataCallType

Data call type.

#### Members

QMI_WDS_DATA_CALL_TYPE_UNKNOWN | data call type unknown. |
QMI_WDS_DATA_CALL_TYPE_EMBEDDED | embedded data call. |
QMI_WDS_DATA_CALL_TYPE_TETHERED | tethered data call. |
QMI_WDS_DATA_CALL_TYPE_MODEM_EMBEDDED | modem embedded data call. |

Since: 1.18

### enum QmiWdsDataSystem

Data system type.

#### Members

QMI_WDS_DATA_SYSTEM_UNKNOWN | unknown |
QMI_WDS_DATA_SYSTEM_CDMA1X | CDMA 1x |
QMI_WDS_DATA_SYSTEM_CDMA1X_EVDO | CDMA 1x EVDO |
QMI_WDS_DATA_SYSTEM_GPRS | GPRS |
QMI_WDS_DATA_SYSTEM_WCDMA | WCDMA |
QMI_WDS_DATA_SYSTEM_LTE | LTE |
QMI_WDS_DATA_SYSTEM_TDSCDMA | TD-SCDMA. |

Since: 1.18

### enum QmiWdsDormancyStatus

Dormancy status.

#### Members

QMI_WDS_DORMANCY_STATUS_UNKNOWN | dormancy status unknown. |
QMI_WDS_DORMANCY_STATUS_TRAFFIC_CHANNEL_DORMANT | traffic channel is dormant. |
QMI_WDS_DORMANCY_STATUS_TRAFFIC_CHANNEL_ACTIVE | traffic channel is active. |

Since: 1.18

### enum QmiWdsExtendedDataBearerTechnology3gpp

3GPP extended data bearer technologies.

#### Members

QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_UNKNOWN | unknown. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_WCDMA | WCDMA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_HSDPA | HSDPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_HSUPA | HSUPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_HSDPA_PLUS | HSDPA+. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_DC_HSDPA_PLUS | Dual-cell HSDPA+. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_64QAM | 64-QAM. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_HSPA | HSPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_GPRS | GPRS. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_EDGE | EDGE. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_GSM | GSM. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_S2B | S2B. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_LTE_LIMITED_SERVICE | LTE limited service. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_LTE_FDD | LTE FDD. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP_LTE_TDD | LTE TDD. |

Since: 1.18

### enum QmiWdsExtendedDataBearerTechnology3gpp2

3GPP2 extended data bearer technologies.

#### Members

QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_UNKNOWN | unknown. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_RESERVED | reserved. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_CDMA1X_IS95 | CDMA1x IS-95. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_CDMA1X_IS2000 | CDMA1x IS-2000. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_CDMA1X_IS2000_REL_A | CDMA1x IS-2000 Release A. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_HDR_REV_0_DPA | HDR EVDO Rev 0 DPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_HDR_REV_A_DPA | HDR EVDO Rev A DPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_HDR_REV_B_DPA | HDR EVDO Rev B DPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_HDR_REV_A_MPA | HDR EVDO Rev A MPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_HDR_REV_B_MPA | HDR EVDO Rev B MPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_HDR_REV_A_EMPA | HDR EVDO Rev A EMPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_HDR_REV_B_EMPA | HDR EVDO Rev B EMPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_HDR_REV_B_MMPA | HDR EVDO Rev B MMPA. |
QMI_WDS_EXTENDED_DATA_BEARER_TECHNOLOGY_3GPP2_HDR_EVDO_FMC | HDR EVDO FMC. |

Since: 1.18

### enum QmiWdsRadioAccessTechnology

Radio access technology.

#### Members

QMI_WDS_RADIO_ACCESS_TECHNOLOGY_NULL_BEARER | null bearer |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP_WCDMA | WCDMA. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP_GERAN | GERAN. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP_LTE | LTE. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP_TDSCDMA | TD-SDCMA. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP_WLAN | 3GPP WLAN. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP_MAXIMUM | 3GPP maximum. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP2_1X | CDMA 1x. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP2_HRPD | CDMA EVDO, HRPD. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP2_EHRPD | CDMA EVDO with eHRPD. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP2_WLAN | 3GPP2 WLAN. |
QMI_WDS_RADIO_ACCESS_TECHNOLOGY_3GPP2_MAXIMUM | 3GPP2 maximum. |

Since: 1.18

### enum QmiWdsSetEventReportTransferStatistics

Flags indicating which WDS Set Event Report Transfer Statistics indicators should be emitted.

#### Members

QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_TX_PACKETS_OK | report TX packet successes. |
QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_RX_PACKETS_OK | report RX packet successes. |
QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_TX_PACKETS_ERROR | report TX packet errors. |
QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_RX_PACKETS_ERROR | report RX packet errors. |
QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_TX_OVERFLOWS | report TX overflows. |
QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_RX_OVERFLOWS | report RX overflows. |
QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_TX_BYTES_OK | report TX byte total. |
QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_RX_BYTES_OK | report RX byte total. |
QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_TX_PACKETS_DROPPED | report TX packets dropped. |
QMI_WDS_SET_EVENT_REPORT_TRANSFER_STATISTICS_REPORT_RX_PACKETS_DROPPED | report RX packets dropped. |

Since: 1.18

### enum QmiWdsSoEvdoRev0

Flags specifying the Service Option when the bearer network type is `QMI_WDS_NETWORK_TYPE_3GPP2` and when the Radio Access Technology mask contains `QMI_WDS_RAT_3GPP2_EVDO_REV0` .

#### Members

QMI_WDS_SO_EVDO_REV0_NONE | Unknown, to be ignored. |
QMI_WDS_SO_EVDO_REV0_DPA | DPA. |

Since: 1.18

### enum QmiWdsSoEvdoRevB

Flags specifying the Service Option when the bearer network type is `QMI_WDS_NETWORK_TYPE_3GPP2` and when the Radio Access Technology mask contains `QMI_WDS_RAT_3GPP2_EVDO_REVB` .

#### Members

QMI_WDS_SO_EVDO_REVB_NONE | Unknown, to be ignored. |
QMI_WDS_SO_EVDO_REVB_DPA | DPA. |
QMI_WDS_SO_EVDO_REVB_MFPA | MFPA. |
QMI_WDS_SO_EVDO_REVB_EMPA | EMPA. |
QMI_WDS_SO_EVDO_REVB_EMPA_EHRPD | EMPA eHRPD. |
QMI_WDS_SO_EVDO_REVB_MMPA | MMPA. |
QMI_WDS_SO_EVDO_REVB_MMPA_EHRPD | MMPA eHRPD. |

Since: 1.18

### enum QmiWdsTetheredCallType

Tethered call type.

#### Members

QMI_WDS_TETHERED_CALL_TYPE_NON_TETHERED | non-tethered. |
QMI_WDS_TETHERED_CALL_TYPE_RMNET | RmNet. |
QMI_WDS_TETHERED_CALL_TYPE_DUN | DUN. |

Since: 1.18

### enum QmiWdsAttachPdnListAction

Action when setting the attach PDN list.

#### Members

QMI_WDS_ATTACH_PDN_LIST_ACTION_NONE | No action (default) |
QMI_WDS_ATTACH_PDN_LIST_ACTION_DETACH_OR_PDN_DISCONNECT | PS detach or PDN disconnect based on the modem configuration |

Since: 1.28

### enum QmiWdsClientType

Client Type

#### Members

QMI_WDS_CLIENT_TYPE_TETHERED | client type tethered |
QMI_WDS_CLIENT_TYPE_UNDEFINED | no client type defined |

Since: 1.18

### enum QmiWdsIpSupportType

IP support type.

#### Members

QMI_WDS_IP_SUPPORT_TYPE_IPV4 | IPv4 type. |
QMI_WDS_IP_SUPPORT_TYPE_IPV6 | IPv6 type. |
QMI_WDS_IP_SUPPORT_TYPE_IPV4V6 | IPv4v6 type. |

Since: 1.28

### QMI_WDS_RATE_UNAVAILABLE

    #define QMI_WDS_RATE_UNAVAILABLE 0xFFFFFFFF

The TX/RX rate information is unavailable or cannot be measured.

Since: 1.22.4